## ros-one-hardware-interface 0.20.0-1jammy.20260220.2057

=== debian/changelog ===
ros-one-hardware-interface (0.20.0-1jammy.20260220.2057) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 20 Feb 2026 20:57:54 +0000

ros-one-hardware-interface (0.20.0-0jammy) jammy; urgency=high

  * Add JPVTPIDGains-like interface (#515 <https://github.com/ros-controls/ros_control/issues/515>)
  * Contributors: Bence Magyar, Wolfgang Merkt

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Oct 2023 00:00:00 -0000

ros-one-hardware-interface (0.19.6-0jammy) jammy; urgency=high

  * Update mainpage.dox (#496 <https://github.com/ros-controls/ros_control/issues/496>)
  * Contributors: PaddyCube

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Oct 2022 00:00:00 -0000

ros-one-hardware-interface (0.19.5-0jammy) jammy; urgency=high

  * Correct exception msg for missing abs pos ptr
  * fix broken links by making them relative
  * Contributors: G.A. vd. Hoorn, Mikael Arguedas

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 16 Jun 2021 00:00:00 -0000

ros-one-hardware-interface (0.19.4-0jammy) jammy; urgency=high

  * Clarified documentation for InterfaceManager sub-manager handling
  * Updated InterfaceManager documentation
  * Removed duplicate error message
    Previously, trying to combine two non-ResourceManager interfaces yielded
    two identical error messages.
  * Remove inconsistent InterfaceManager manager registering behavior
    All InterfaceManager now handle registered InterfaceManagers
    transparently. This allows chains of multiple InterfaceManagers
    registered to each other to work corectly, mostly relevant for
    registering a manager from a combined_robot_hw RobotHW.
    Resolves #452 <https://github.com/ros-controls/ros_control/issues/452>
  * Contributors: Robert Wilbrandt

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Dec 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.3-0jammy) jammy; urgency=high

  * Update mainpage.dox
    - Explain JointStateInterface and PositionJointInterface
    - Explain how to use potential software transmissions
    - Link to transmission_interface examples
  * Update doc of robot_hw.h
    - Use JointStateHandle in case of read-only operations
  * doc: add README.md for hardware_interface
  * doc: add mainpage.dox including examples
  * doc: update robot_hw.h docstrings
    update docstring of class and init method.
  * Contributors: Franz Pucher, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 11 Oct 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.2-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 17 Aug 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.1-0jammy) jammy; urgency=high

  * Function specifiers noetic (#453 <https://github.com/ros-controls/ros_control/issues/453>)
    * Add override specifiers & default constructors
    * Delete ControllerBase copy & move ctors
    * Remove unnecessary default constructors
    * Modernize additional constructors
    * Revert ImuSensorHandle::Data::Data() = default
    * Remove unnecessary default overridden constructors
    * Remove semicolon after function body
    Co-authored-by: Matt Reynolds <mtreynolds@uwaterloo.ca>
  * [hardware_interface::RobotHW] doc: update read and write, fix: group names (#444 <https://github.com/ros-controls/ros_control/issues/444>) (#454 <https://github.com/ros-controls/ros_control/issues/454>)
  * Use setuptools instead of distutils (#429 <https://github.com/ros-controls/ros_control/issues/429>)
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 10 May 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.0-0jammy) jammy; urgency=high

  * Remove deprecated ForceTorqueHandle ctor (#437 <https://github.com/ros-controls/ros_control/issues/437>)
  * Replace enums with enum classes (#412 <https://github.com/ros-controls/ros_control/issues/412>)
  * Use CamelCase for ResourceManagerType typedef (#438 <https://github.com/ros-controls/ros_control/issues/438>)
  * Contributors: Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Apr 2020 00:00:00 -0000

ros-one-hardware-interface (0.18.0-0jammy) jammy; urgency=high

  * Bump CMake version to avoid CMP0048 (#427 <https://github.com/ros-controls/ros_control/issues/427>)
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 16 Apr 2020 00:00:00 -0000

ros-one-hardware-interface (0.17.0-0jammy) jammy; urgency=high

  * Use default member initializers
  * Use braces for member initializers
  * Replace boost with std
  * Replace boost::ptr_vector<T> with std::vector<T*>
  * Contributors: AbhinavSingh, Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Feb 2020 00:00:00 -0000

ros-one-hardware-interface (0.16.0-0jammy) jammy; urgency=high

  * Merge pull request #413 <https://github.com/ros-controls/ros_control/issues/413> from matthew-reynolds/range-for
    Use range-based for loop
  * Use more meaningful pair iterator names
  * Correct typo in interface_manager.h
    Co-Authored-By: Bence Magyar <mailto:bence.magyar.robotics@gmail.com>
  * Merge pull request #404 <https://github.com/ros-controls/ros_control/issues/404> from matthew-reynolds/catkin-lint
    Update CMakeLists.txt and package.xml
  * Use range-based for loops in hardware_interface
  * Resolve Boost dependency issues
  * Update dependencies
    - Dependencies needed to compile are <build_depend>
    - Dependencies used in public headers are <build_export_depend>
    - Dependencies needed to link or run are <exec_depend>
  * Merge branch 'melodic-devel' into catkin-lint
  * Update package dependencies
  * Remove rosunit test_depend from package.xml
  * Merge pull request #405 <https://github.com/ros-controls/ros_control/issues/405> from matthew-reynolds/use-nullptr
    Use nullptr
  * Use nullptr in tests


## ros-one-hardware-interface 0.20.0-1noble.20251022.2354

=== debian/changelog ===
ros-one-hardware-interface (0.20.0-1noble.20251022.2354) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 22 Oct 2025 23:54:53 +0000

ros-one-hardware-interface (0.20.0-0noble) noble; urgency=high

  * Add JPVTPIDGains-like interface (#515 <https://github.com/ros-controls/ros_control/issues/515>)
  * Contributors: Bence Magyar, Wolfgang Merkt

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Oct 2023 00:00:00 -0000

ros-one-hardware-interface (0.19.6-0noble) noble; urgency=high

  * Update mainpage.dox (#496 <https://github.com/ros-controls/ros_control/issues/496>)
  * Contributors: PaddyCube

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Oct 2022 00:00:00 -0000

ros-one-hardware-interface (0.19.5-0noble) noble; urgency=high

  * Correct exception msg for missing abs pos ptr
  * fix broken links by making them relative
  * Contributors: G.A. vd. Hoorn, Mikael Arguedas

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 16 Jun 2021 00:00:00 -0000

ros-one-hardware-interface (0.19.4-0noble) noble; urgency=high

  * Clarified documentation for InterfaceManager sub-manager handling
  * Updated InterfaceManager documentation
  * Removed duplicate error message
    Previously, trying to combine two non-ResourceManager interfaces yielded
    two identical error messages.
  * Remove inconsistent InterfaceManager manager registering behavior
    All InterfaceManager now handle registered InterfaceManagers
    transparently. This allows chains of multiple InterfaceManagers
    registered to each other to work corectly, mostly relevant for
    registering a manager from a combined_robot_hw RobotHW.
    Resolves #452 <https://github.com/ros-controls/ros_control/issues/452>
  * Contributors: Robert Wilbrandt

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Dec 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.3-0noble) noble; urgency=high

  * Update mainpage.dox
    - Explain JointStateInterface and PositionJointInterface
    - Explain how to use potential software transmissions
    - Link to transmission_interface examples
  * Update doc of robot_hw.h
    - Use JointStateHandle in case of read-only operations
  * doc: add README.md for hardware_interface
  * doc: add mainpage.dox including examples
  * doc: update robot_hw.h docstrings
    update docstring of class and init method.
  * Contributors: Franz Pucher, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 11 Oct 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.2-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 17 Aug 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.1-0noble) noble; urgency=high

  * Function specifiers noetic (#453 <https://github.com/ros-controls/ros_control/issues/453>)
    * Add override specifiers & default constructors
    * Delete ControllerBase copy & move ctors
    * Remove unnecessary default constructors
    * Modernize additional constructors
    * Revert ImuSensorHandle::Data::Data() = default
    * Remove unnecessary default overridden constructors
    * Remove semicolon after function body
    Co-authored-by: Matt Reynolds <mtreynolds@uwaterloo.ca>
  * [hardware_interface::RobotHW] doc: update read and write, fix: group names (#444 <https://github.com/ros-controls/ros_control/issues/444>) (#454 <https://github.com/ros-controls/ros_control/issues/454>)
  * Use setuptools instead of distutils (#429 <https://github.com/ros-controls/ros_control/issues/429>)
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 10 May 2020 00:00:00 -0000

ros-one-hardware-interface (0.19.0-0noble) noble; urgency=high

  * Remove deprecated ForceTorqueHandle ctor (#437 <https://github.com/ros-controls/ros_control/issues/437>)
  * Replace enums with enum classes (#412 <https://github.com/ros-controls/ros_control/issues/412>)
  * Use CamelCase for ResourceManagerType typedef (#438 <https://github.com/ros-controls/ros_control/issues/438>)
  * Contributors: Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Apr 2020 00:00:00 -0000

ros-one-hardware-interface (0.18.0-0noble) noble; urgency=high

  * Bump CMake version to avoid CMP0048 (#427 <https://github.com/ros-controls/ros_control/issues/427>)
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 16 Apr 2020 00:00:00 -0000

ros-one-hardware-interface (0.17.0-0noble) noble; urgency=high

  * Use default member initializers
  * Use braces for member initializers
  * Replace boost with std
  * Replace boost::ptr_vector<T> with std::vector<T*>
  * Contributors: AbhinavSingh, Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Feb 2020 00:00:00 -0000

ros-one-hardware-interface (0.16.0-0noble) noble; urgency=high

  * Merge pull request #413 <https://github.com/ros-controls/ros_control/issues/413> from matthew-reynolds/range-for
    Use range-based for loop
  * Use more meaningful pair iterator names
  * Correct typo in interface_manager.h
    Co-Authored-By: Bence Magyar <mailto:bence.magyar.robotics@gmail.com>
  * Merge pull request #404 <https://github.com/ros-controls/ros_control/issues/404> from matthew-reynolds/catkin-lint
    Update CMakeLists.txt and package.xml
  * Use range-based for loops in hardware_interface
  * Resolve Boost dependency issues
  * Update dependencies
    - Dependencies needed to compile are <build_depend>
    - Dependencies used in public headers are <build_export_depend>
    - Dependencies needed to link or run are <exec_depend>
  * Merge branch 'melodic-devel' into catkin-lint
  * Update package dependencies
  * Remove rosunit test_depend from package.xml
  * Merge pull request #405 <https://github.com/ros-controls/ros_control/issues/405> from matthew-reynolds/use-nullptr
    Use nullptr
  * Use nullptr in tests


## ros-one-hardware-interface 0.20.0-1noble.20260220.2101

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(hardware_interface)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  roscpp
)

# Declare a catkin package
catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    roscpp
)


###########
## Build ##
###########

# Specify header include paths
include_directories(include ${catkin_INCLUDE_DIRS})


#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(hardware_resource_manager_test           test/hardware_resource_manager_test.cpp)
  target_link_libraries(hardware_resource_manager_test      ${catkin_LIBRARIES})

  catkin_add_gtest(actuator_state_interface_test            test/actuator_state_interface_test.cpp)
  target_link_libraries(actuator_state_interface_test       ${catkin_LIBRARIES})

  catkin_add_gtest(actuator_command_interface_test          test/actuator_command_interface_test.cpp)
  target_link_libraries(actuator_command_interface_test     ${catkin_LIBRARIES})

  catkin_add_gtest(joint_state_interface_test               test/joint_state_interface_test.cpp)
  target_link_libraries(joint_state_interface_test          ${catkin_LIBRARIES})

  catkin_add_gtest(joint_command_interface_test             test/joint_command_interface_test.cpp)
  target_link_libraries(joint_command_interface_test        ${catkin_LIBRARIES})

  catkin_add_gtest(force_torque_sensor_interface_test       test/force_torque_sensor_interface_test.cpp)
  target_link_libraries(force_torque_sensor_interface_test  ${catkin_LIBRARIES})

  catkin_add_gtest(imu_sensor_interface_test                test/imu_sensor_interface_test.cpp)
  target_link_libraries(imu_sensor_interface_test           ${catkin_LIBRARIES})

  catkin_add_gtest(robot_hw_test                            test/robot_hw_test.cpp)
  target_link_libraries(robot_hw_test                       ${catkin_LIBRARIES})

  catkin_add_gtest(interface_manager_test                   test/interface_manager_test.cpp)
  target_link_libraries(interface_manager_test              ${catkin_LIBRARIES})

  catkin_add_gtest(posvel_command_interface_test            test/posvel_command_interface_test.cpp)
  target_link_libraries(posvel_command_interface_test       ${catkin_LIBRARIES})

  catkin_add_gtest(posvelacc_command_interface_test         test/posvelacc_command_interface_test.cpp)
  target_link_libraries(posvelacc_command_interface_test    ${catkin_LIBRARIES})
endif()


#############
## Install ##
#############

# Install headers
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

=== debian/changelog ===
ros-one-hardware-interface (0.20.0-1noble.20260220.2101) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 20 Feb 2026 21:01:15 +0000

=== debian/control ===
Source: ros-one-hardware-interface
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-roscpp
Homepage: https://github.com/ros-controls/ros_control/wiki
Standards-Version: 3.9.2

Package: ros-one-hardware-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-roscpp
Description: Hardware Interface base class.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-hardware-interface//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install
